{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            Client:{routeName:'BaseController-getComboValues',table:'clients'}
            ,ClientG:{routeName:'BaseController-getComboValues',table:'clients'}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            //t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            const gridConfig = {
                selectMode : 'cell',
                cm: [
                    {header: "{{ 'TaskPlan.client'|trans }}", dataIndex: 'client', width: 100,filter:'single',alias:'tp',type:'combo',store:t.stores.ClientG,operator:'='},
                    {header: "{{ 'TaskPlan.opname'|trans }}", dataIndex: 'opname', width: 200,filter:'single',alias:'tp',operator:'%.%'},
                    {header: "{{ 'TaskPlan.erprefnumber'|trans }}", dataIndex: 'erprefnumber', width: 80,filter:'single', alias:'tp',operator:'='},
                    {header: "{{ 'TaskPlan.productcount'|trans }}", dataIndex: 'productcount', width: 60,align:'right'},
                    {header: "{{ 'TaskPlan.deadline'|trans }}", dataIndex: 'deadline', width: 70,filter:'between',type:'date',alias:'tp'},
                    {header: "{{ 'TaskPlan.issendbyforce'|trans }}", dataIndex: 'issendbyforce', width: 50,renderer:mj.renderer.check(),alias:'tp'},
                    {header: "{{ 'TaskPlan.status'|trans }}", dataIndex: 'status', width: 60,alias:'tp'},
                    {header: "{{ 'TaskPlan.idx'|trans }}", dataIndex: 'idx', width: 150,alias:'tp'}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    })
                    
                ]
            };

            t._setFormConfig(formConfig);
            t.stores.export = new mj.store({url : '',params : {}});
            t.stores.export.on('load',function(data){
                t.waitMaskHide();
                t.grids.main.load();
            });
            t.buttons.edit.setEnable();
            if(typeof t.grids.main.pbar.tbar.addSplitter==='function'){
				t.grids.main.pbar.tbar.addSplitter();
			}
            t.buttons.export = t.grids.main.pbar.tbar.addButton({
                alt: "{{ 'TaskPlan.export'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-compile',
                scope: t,
                handler: t._onExportButtonClick
			});
            t.buttons.saveAsXLS = t.grids.main.pbar.tbar.addButton({
                alt: mj.lng.glb.saveAsXLS,
                cls: 'btn-sm left',
                iconCls: 'mj-save-as-xls',
                scope: t,
                handler: t._onButtonSaveAsXLSClick
			});
            t.grids.main.on('cellclick',function(g,ri,ci,ce){
                //console.log('cellclick',g,ri,ci,ce);
                if(ci===6){
                    t.grids.main.selectedRow.data = t.grids.main.store.data[ri];
                    var d = t.grids.main.selectedRow.data;
                    if(d.issendbyforce===1){
                        t.grids.main.setCellValue(ri,5,0,mj.renderer.check(),true);
                        d.issendbyforce=0;
                    }else{
                        t.grids.main.setCellValue(ri,5,1,mj.renderer.check(),true);
                        d.issendbyforce=1;
                    }
                }
                
            });
        },
        _onMainStoreLoad: function() {
            var t = this;
		    t.trigger('mainstoreload', t);
            if(t._event!==false){
                if(t._event==='save'){
                    t.activateTabGrid();
                }
            }
            this.waitMaskHide();
            return true;
        },
        _onButtonEditClick: function(a) {
            var t = this;
            var tmp1=[];
            var tmp0=[];
            for(var i=0;i<t.grids.main.store.data.length;i++){
                var row=t.grids.main.store.data[i];
                if(row.issendbyforce===1){
                    tmp1.push(row.id); 
                }else{
                    tmp0.push(row.id); 
                }
            }
            if(tmp1.length>0||tmp0.length>0){
                var data =  t.forms.main.getValue();
                var routeName = t.modulename + '-updateIdx';
                var route = Routing.getRoute(routeName);
                var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                    'pg': t.grids.main.pbar.current,
                    'lm': t.grids.main.pbar.limit
                } : {};
                var url = Routing.generate(routeName, pagerParams);
                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    t.waitMaskShow();
                    data.menuId=t.id;
                    data.recordIds1=tmp1;
                    data.recordIds0=tmp0;
                    $.ajax({
                        url: url,
                        method: 'POST',
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0] 
                        },
                        dataType: 'json',
                        data: JSON.stringify(data),
                        success: function(data, textStatus, jqXHR) {
                            //console.log('success',data, textStatus, jqXHR);
                            t.waitMaskHide();
                            t.grids.main.load();
                        },
                        error: function(jqXHR, textStatus, errorThrown) {
                            t.waitMaskHide();
                            mj.message({
                                title: mj.lng.glb.error,
                                msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                type: "error",
                                html: true
                            });
                            t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
                        },
                        complete: function(jqXHR, textStatus) {
                            //t.waitMaskHide();
                        }
                    });
                }
            }
	    },
        _onExportButtonClick:function(a){
            var t = this;
            //console.log('_onExportButtonClick',a);
            t.waitMaskShow();
            var routeName = 'TaskExport-add';
            var route = Routing.getRoute(routeName);
            var pagerParams = {'pg':1,'lm':20};
            var url = Routing.generate(routeName, pagerParams);
            t.stores.export.url=url;
            t.stores.export.preloaded=false;
            t.stores.export.params.menuId=t.id;
            t.stores.export.load();
        },
        _onButtonSaveAsXLSClick:function(){
            var t = this;
            t.waitMaskShow();
            var routeName = 'Reports-add';
            var route = Routing.getRoute(routeName);
            var pagerParams = {'pg':1,'lm':25};
            var url = Routing.generate(routeName, pagerParams);
            if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                $.ajax({
                    url: url,
                    method: "POST",
                    headers: { 
                        "Content-Type": "application/json",
                        "X-HTTP-Method-Override": route.methods[0] 
                    },
                    data: JSON.stringify({reportname:'TaskPlanAll'}),
                    dataType: 'binary',
                    processData: false,
                    success: function(data, textStatus, xhr) {
                        //t.activateTabGrid();
                        if(textStatus==='success'){
                            var filename = "";
                            var disposition = xhr.getResponseHeader('Content-Disposition');
                            if (disposition && disposition.indexOf('attachment') !== -1) {
                                var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                                var matches = filenameRegex.exec(disposition);
                                if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                            }
                            var type = xhr.getResponseHeader('Content-Type');
                            var blob = typeof File === 'function'
                                ? new File([data], filename, { type: type })
                                : new Blob([data], { type: type });
                            if (typeof window.navigator.msSaveBlob !== 'undefined') {
                                // IE workaround for "HTML7007: One or more blob URLs were revoked by closing the blob for which they were created. These URLs will no longer resolve as the data backing the URL has been freed."
                                window.navigator.msSaveBlob(blob, filename);
                                t.waitMaskHide();
                            } else {
                                var URL = window.URL || window.webkitURL;
                                var downloadUrl = URL.createObjectURL(blob);
                                if (filename) {
                                    // use HTML5 a[download] attribute to specify filename
                                    var a = document.createElement("a");
                                    // safari doesn't support this yet
                                    if (typeof a.download === 'undefined') {
                                        window.location = downloadUrl;
                                        t.waitMaskHide();
                                    } else {
                                        a.href = downloadUrl;
                                        a.download = filename;
                                        document.body.appendChild(a);
                                        a.click();
                                        t.waitMaskHide();
                                    }
                                } else {
                                    window.location = downloadUrl;
                                    t.waitMaskHide();
                                }

                                setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100); // cleanup
                            }
                        }
                    },
                    error: function(xhr, textStatus, errorThrown) {
                        t.waitMaskHide();
                        if(xhr.responseJSON&&xhr.responseJSON.message){
                            mj.message({
                                title: mj.lng.glb.error,
                                msg: xhr.responseJSON.message,
                                type: "error",
                                html: true
                            });
                        }
                    },
                    complete: function(jqXHR, textStatus) {
                        t.waitMaskHide();
                    }
                });
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
